// USBD096Dlg.cpp : implementation file
// Author : Philip Allen
// Version :1.1
// Date   : 16 March 2006
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Comm.h"
#include "Relay.h"
#include "USBD096.h"
#include "USBD096Dlg.h"
#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class CPort;

CRelay GRelays("Com1");

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CUSBD096Dlg dialog

CUSBD096Dlg::CUSBD096Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBD096Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSBD096Dlg)
	m_edtActiveBank = 0;
	m_edtActiveRelay = 0;
	m_txtIntVal = 0;
	m_txtPortNum = 0;
	m_edtSingleRelay = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	

}

void CUSBD096Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSBD096Dlg)
	DDX_Control(pDX, IDC_INT_SCROLLBAR, m_vsbCycleInterval);
	DDX_Control(pDX, IDC_COM_PORT_NUM, m_txt_ComPortNum);
	DDX_Control(pDX, IDC_REL_CYCLE, m_txtRelayCycle);
	DDX_Control(pDX, IDC_SINGLE_REL_NUM, m_edRelayNum);
	DDX_Text(pDX, IDC_ED_BANK, m_edtActiveBank);
	DDX_Text(pDX, IDC_ED_REL, m_edtActiveRelay);
	DDX_Text(pDX, IDC_INT_VAL, m_txtIntVal);
	DDX_Text(pDX, IDC_COM_PORT_NUM, m_txtPortNum);
	DDX_Text(pDX, IDC_SINGLE_REL_NUM, m_edtSingleRelay);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSBD096Dlg, CDialog)
	//{{AFX_MSG_MAP(CUSBD096Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_RECYCLE_ON, OnRecycleOn)
	ON_BN_CLICKED(IDC_RECYCLE_OFF, OnRecycleOff)
	ON_EN_CHANGE(IDC_SINGLE_REL_NUM, OnChangeSingleRelNum)
	ON_COMMAND(IDM__COMMPORT1, OnCommport1)
	ON_COMMAND(IDM__COMMPORT2, OnCommport2)
	ON_COMMAND(IDM__COMMPORT3, OnCommport3)
	ON_COMMAND(IDM__COMMPORT4, OnCommport4)
	ON_COMMAND(IDM__COMMPORT5, OnCommport5)
	ON_COMMAND(IDM_FILE_EXIT, OnFileExit)
	ON_WM_VSCROLL()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBD096Dlg message handlers

BOOL CUSBD096Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	
	// Set pointers to Com port sub menu items 
	m_mainMenu = GetMenu();
	m_pmnuPort = m_mainMenu->GetSubMenu(1);

	// Initialise scroll bar
	m_vsbCycleInterval.SetScrollRange(10,1000,TRUE);
	m_vsbCycleInterval.SetScrollPos(500, FALSE);
	mVScrollPos = 500;
	m_txtIntVal = mVScrollPos;

	// Set dafault port
	mPort = 1;
	m_txtPortNum = mPort;
	UpdateData(FALSE);

	// Initialse controls
	SetUpControls();
    EnableControls();
    mbRecycleOn = false;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUSBD096Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSBD096Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSBD096Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUSBD096Dlg::SetUpControls(void)
{
	// 
	mRelayCycStart.SubclassDlgItem(IDC_START, this);
	mRelayClose.SubclassDlgItem(IDC_CLOSE, this);
	mRelayOpen.SubclassDlgItem(IDC_OPEN, this);
	mRelayClear.SubclassDlgItem(IDC_CLEAR, this);
	mRelayRecycleOn.SubclassDlgItem(IDC_RECYCLE_ON, this);
	mRelayRecycleOff.SubclassDlgItem(IDC_RECYCLE_OFF, this);
	mMenuCommPort1.SubclassDlgItem(IDM__COMMPORT1, this);
	mMenuCommPort2.SubclassDlgItem(IDM__COMMPORT2, this);
	mMenuCommPort3.SubclassDlgItem(IDM__COMMPORT3, this);
	mMenuCommPort4.SubclassDlgItem(IDM__COMMPORT4, this);
	mMenuCommPort5.SubclassDlgItem(IDM__COMMPORT5, this);
	mMenuCommPortSel.SubclassDlgItem(IDM_SELECTPORT, this);
	mMenuFileExit.SubclassDlgItem(IDM_FILE_EXIT, this);	
}


void CUSBD096Dlg::EnableControls()
{
	// 
    mRelayOpen.EnableWindow(true);
    mRelayClose.EnableWindow(true);
    mRelayClear.EnableWindow(true);
    mRelayCycStart.EnableWindow(true);
	m_txtRelayCycle.ShowWindow(1);
	m_txtRelayCycle.SetWindowText("Recycling Off");
    Initialise();
}


void CUSBD096Dlg::DisableControls()
{

    mRelayOpen.EnableWindow(false);
    mRelayClose.EnableWindow(false);
    mRelayClear.EnableWindow(false);
    mRelayCycStart.EnableWindow(false);

}


void CUSBD096Dlg::Initialise()
{
    
    // set Controls
    mRelayRecycleOff.SetCheck( true);
    mRelayRecycleOn.SetCheck(false);
    mRelaysCycling = false;
	mRelayRecycleOn.SetCheck(FALSE);
	mRelayRecycleOff.SetCheck(TRUE);
	mbRecycleOn = false;

    // Set all PIC ports to Outputs
    GRelays.SetPortStates ("OUTPUT");
    
    GRelays.ClearRelays();

	// Set text boxes
	muRelayPos = 0;
	muBankPos = 1;

	m_edtActiveRelay = muRelayPos;
	m_edtActiveBank =  muBankPos;
	UpdateData(FALSE);
}



// Used by OnOpen/OnClose to convert a relay number to the
// appropriate relay and bank values.
bool CUSBD096Dlg::CalculateBankAndRelay(int iRelayNum, int * BankPos, int * RelayPos)
{

    if ( iRelayNum > 0 && iRelayNum <= 96 )
    {
        //Calculate Bank and Relay
        *RelayPos = iRelayNum % GIMAXRELAY;

        if ( *RelayPos == 0 )
        {
            *RelayPos = GIMAXRELAY;
        }
        
        *BankPos = (iRelayNum / 17) + 1;

		return true;
	}
	else
	{
		return false;
	}

}


// This function is called each time the timer expires
// It will increment the relay to be open /closed and
// when all 16 are accessed, will move to the next bank
// starting back at relay 1.
// When all relays are closed it will do the same to open
// each relay.
void CUSBD096Dlg::Scan_Relays(void)
{

    // for this cycle check if reached max relay in bank 
	if ( muRelayPos < GIMAXRELAY )
    {
        // increment for next relay
		muRelayPos = muRelayPos + 1;
    }
    else
    { 
        // have reached top of bank so reset relay back to 1 an increment
		// for next bank
		muRelayPos = 1;
         if ( muBankPos < GIMAXBANK )
         {
            // have not reached last bank so increment to next
			 muBankPos = muBankPos + 1;
         }
    }
        
    if ( mbCloseRelays == true )
    {
        GRelays.CloseRelay (muRelayPos, muBankPos);
		m_txtRelayCycle.SetWindowText("Closing Relay:");

    }
    else
    {
		GRelays.OpenRelay (muRelayPos, muBankPos );
		m_txtRelayCycle.SetWindowText("Opening Relay:");
    }
 
	UpdateData(FALSE);

    // Check if reached end of Scan for Closing
    if ( muBankPos == GIMAXBANK && muRelayPos >= GIMAXRELAY )
    {
        muBankPos = 5;
        muRelayPos = 15;
        
        if ( mbCloseRelays == true )
        {
            mbCloseRelays = false;
        }
        else
        {
            mbScanComplete = true;
			muBankPos = 1;
			muRelayPos = 0;
        }
    }

	if( mbCloseRelays == true && muBankPos > 1)
	{
		GRelays.OpenRelay (muRelayPos, muBankPos - 1);
	}

}


// Called from the Start relays cycling button
// Disables other controls and starts timer.
// Toggels button function to Stop cycling
void CUSBD096Dlg::OnStart() 
{

	if ( mRelaysCycling == false )
    {
        // Set other controls off
		mRelayClear.EnableWindow( false);
        mRelayClose.EnableWindow( false);
        mRelayOpen.EnableWindow ( false);
		// Change button caption to Stop
        mRelayCycStart.SetWindowText("Stop");
		// Change label to indicate now closing relays
        mbCloseRelays = true;
		m_txtRelayCycle.SetWindowText("Closing Relay:");
		// Set flags to indcate start of cycle
        mbScanComplete = false;
		mRelaysCycling = true;

		// Start Timer
        SetTimer(IDC_INTERVAL_TIMER,mVScrollPos ,NULL);
    }
    else
    {
        // Button now clicked to stop cycling
		// Stop timer
		KillTimer(IDC_INTERVAL_TIMER);
        
		// Set other controls to Active
		mRelayClear.EnableWindow(true);
        mRelayClose.EnableWindow(true);
        mRelayOpen.EnableWindow (true);
		// Set label to indicate relays not cycling
        m_txtRelayCycle.SetWindowText("Cycling Off:");
		// Change button caption to Start
        mRelayCycStart.SetWindowText("Start");
		// Change button toggle
		mRelaysCycling = false;
    }
	
}


// Called from the Close Relay button
// Reads and converts the value in the edit box
// into the correct relay and bank values
// and then calls function to close relay
void CUSBD096Dlg::OnClose() 
{
    int iRelayNum;
    int iRelay;
    int iBank;
	CString sRelValue;

	m_edRelayNum.GetWindowText(sRelValue);

	iRelayNum = atoi(sRelValue);

    if (CalculateBankAndRelay(iRelayNum, &iBank, &iRelay) == true)
    {
                
        GRelays.CloseRelay (iRelay, iBank);
    }
    else
    {
        MessageBox ("Value out of range", "Relay Number", MB_OK);
    }
	
}


// Called from the Open Relay button
// Reads and converts the value in the edit box
// into the correct relay and bank values
// and then calls function to open relay
void CUSBD096Dlg::OnOpen() 
{
    int iRelayNum;
    int iRelay;
    int iBank;
	CString sRelValue;

	m_edRelayNum.GetWindowText(sRelValue);

	iRelayNum = atoi(sRelValue);
    
    if (CalculateBankAndRelay(iRelayNum, &iBank, &iRelay) == true)
    {
       //Calculate Bank and Relay
       GRelays.OpenRelay (iRelay, iBank);
    }
    else
    {
        MessageBox ("Value out of range", "Relay Number", MB_OK);
    } 
}


// Called from the Clear Relays Button
void CUSBD096Dlg::OnClear() 
{
    GRelays.ClearRelays();

	// Set text boxes
    m_edtActiveRelay = 0;
    m_edtActiveBank = 0;
	muRelayPos = 0;
	muBankPos = 1;
	m_edtSingleRelay = 0;
	UpdateData(FALSE);
	
}


// Called from the Recycle On radio button
void CUSBD096Dlg::OnRecycleOn() 
{
    mbRecycleOn = true;

	if ( mRelayRecycleOff.GetCheck() == TRUE )
	{
		mRelayRecycleOff.SetCheck(FALSE);
	}
	else
	{
		mRelayRecycleOn.SetCheck(TRUE);
	}
	
}


// Called from the Recycle Off radio button
void CUSBD096Dlg::OnRecycleOff() 
{
    mbRecycleOn = false;

	if ( mRelayRecycleOn.GetCheck() == TRUE )
	{
		mRelayRecycleOn.SetCheck(FALSE);
	}
	else
	{
		mRelayRecycleOff.SetCheck(TRUE);
	}
	
}

// Unused
void CUSBD096Dlg::OnChangeSingleRelNum() 
{
	// TODO: Add your control notification handler code here
	
}


// Selects the communication port and sets menu checks
void CUSBD096Dlg::SelectCommPort(int portnum)
{

	m_pmnuPort->CheckMenuItem(0,MF_UNCHECKED | MF_BYPOSITION);
	m_pmnuPort->CheckMenuItem(1,MF_UNCHECKED | MF_BYPOSITION);
	m_pmnuPort->CheckMenuItem(2,MF_UNCHECKED | MF_BYPOSITION);
	m_pmnuPort->CheckMenuItem(3,MF_UNCHECKED | MF_BYPOSITION);
	m_pmnuPort->CheckMenuItem(4,MF_UNCHECKED | MF_BYPOSITION);
    
	m_pmnuPort->CheckMenuItem(portnum - 1,MF_CHECKED | MF_BYPOSITION);


	CString sPortName;

	switch(portnum)
	{
		case 1 : sPortName = "Com1"; break;
		case 2 : sPortName = "Com2"; break;
		case 3 : sPortName = "Com3"; break;
		case 4 : sPortName = "Com4"; break;
		case 5 : sPortName = "Com5"; break;
		default : sPortName = "Com1"; break;
	}


    if (GRelays.SetComPortNum(sPortName) == TRUE )
    {
        m_txtPortNum = mPort;
        EnableControls();
		Initialise();
    } 
    else
    {
        mPort = 0;
        m_txtPortNum = mPort;
        DisableControls();
        MessageBox ("Invalid Comm Port", "COMM PORT", MB_OK | MB_ICONEXCLAMATION);
    }

    UpdateData(FALSE);

}


// The next set of functions are activated from the menu
// port selection
void CUSBD096Dlg::OnCommport1() 
{
	mPort = 1;
	SelectCommPort(mPort);
}

void CUSBD096Dlg::OnCommport2() 
{
	mPort = 2;
	SelectCommPort(mPort);
}


void CUSBD096Dlg::OnCommport3() 
{
	mPort = 3;
	SelectCommPort(mPort);
}


void CUSBD096Dlg::OnCommport4() 
{
	mPort = 4;
	SelectCommPort(mPort);
}


void CUSBD096Dlg::OnCommport5() 
{
	mPort = 5;
	SelectCommPort(mPort);
}



void CUSBD096Dlg::OnFileExit() 
{
   //Check if ( port is open before trying to clear
   if ( mPort != 0 )
   {
      GRelays.ClearRelays();
   }
    
   //Form.close;
	CDialog::OnCancel();
	
}


// Controls the Scroll Bar movements
void CUSBD096Dlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	mVScrollPos = m_vsbCycleInterval.GetScrollPos();

	switch (nSBCode)
	{
	case SB_BOTTOM:      // Scroll to far left.
		mVScrollPos = 0;
		break;

	case SB_TOP:      // Scroll to far right.
		mVScrollPos = 1000;
		break;

	case SB_ENDSCROLL:   // End scroll.
		break;

	case SB_LINEDOWN:      // Scroll down.
		if (mVScrollPos < 1000)
			mVScrollPos+= 10;
		break;

	case SB_LINEUP:   // Scroll up.
		if (mVScrollPos > 10)
			mVScrollPos-= 10;
		break;

	case SB_PAGEUP:    // Scroll one page up.
		{
			if (mVScrollPos > 0)
				mVScrollPos = max(0, mVScrollPos - 100);

		}
		break;

	case SB_PAGEDOWN:      // Scroll one page down
		{
			if (mVScrollPos < 1000)
				mVScrollPos = min(1000, mVScrollPos + 100);
		}
		break;

	case SB_THUMBPOSITION: // Scroll to absolute position. nPos is the position
		mVScrollPos = nPos;      // of the scroll box at the end of the drag operation.
		break;

	case SB_THUMBTRACK:      // Drag scroll box to specified position. nPos is the
		mVScrollPos = nPos; // position that the scroll box has been dragged to.
		break;
	}

	// Set the new position of the thumb (scroll box).
	m_vsbCycleInterval.SetScrollPos(mVScrollPos, TRUE);

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);

	m_txtIntVal = mVScrollPos;
	UpdateData(FALSE);

}


// This function called every time timer expirers
// Calls the Scan relayss function that will step
// through and close/open each relay in turn
void CUSBD096Dlg::OnTimer(UINT nIDEvent) 
{
    Scan_Relays();
    
	if ( mbScanComplete == true )
    {
         if ( mbRecycleOn == false )
         {
            KillTimer(IDC_INTERVAL_TIMER);
			mRelayCycStart.SetWindowText("Start");
			mRelaysCycling = false;
			m_txtRelayCycle.SetWindowText("Cycling Off");

            mRelayClear.EnableWindow(true);
            mRelayOpen.EnableWindow(true);
            mRelayClose.EnableWindow(true);
         }
         else
         {
            mbScanComplete = false;
            mbCloseRelays = true;
        }
    }
    
	m_edtActiveRelay = muRelayPos;
	m_edtActiveBank =  muBankPos;
	UpdateData(FALSE);
	
	CDialog::OnTimer(nIDEvent);
}


BEGIN_EVENTSINK_MAP(CUSBD096Dlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CUSBD096Dlg)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()
